/*
 * Copyright (C) 2014 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.graphab.habitat;

import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import org.thema.common.Util;
import org.thema.common.io.tab.CSVTabReader;
import org.thema.graphab.Project;

/**
 * Dialog form for setting the capacities of the patches with 3 choices :
 * area, neighborhood or external file.
 * 
 * @author Gilles Vuidel
 */
public class CapaPatchDialog extends javax.swing.JDialog {

    /**
     * Parameter class for setting the patch capacity
     */
    public static class CapaPatchParam {
        // Area capacity
        public boolean calcArea = true;
        public Map<Integer, Double> codeWeight;
        public double exp = 1;
        
        // Neighborhood capacity
        public String costName;
        public HashSet<Integer> codes;
        public double maxCost;
        public boolean weightCost;
        // External capacity
        public File importFile = null;
        public String idField, capaField;

        public boolean isCalcArea() {
            return calcArea;
        }
        
        public boolean isArea() {
            if(!calcArea || exp != 1) {
                return false;
            }
            
            return !isWeightedArea();
        }
        
        public boolean isWeightedArea() {
            if(codeWeight == null || codeWeight.isEmpty()) {
                return false;
            }
            for(Double val : codeWeight.values()) {
                if(val != 1.0) {
                    return true;
                }
            }
            return false;
        }
        
    }

    /** has user clicked Ok ? */
    public boolean isOk = false;
    
    /** the parameters for setting patch capacity */
    public CapaPatchParam params;


    /** 
     * Creates new form CapaPatchDialog.
     * @param parent the parent frame
     * @param project the current project
     * @param hab habitat to edit capacity parameters
     */
    public CapaPatchDialog(java.awt.Frame parent, Project project, MonoHabitat hab) {
        super(parent, true);
        initComponents();
        setLocationRelativeTo(parent);
        getRootPane().setDefaultButton(okButton);
        setTitle(getTitle() + " - " + hab.getName());
        this.params = hab.getCapacityParams();
        if(params == null) {
            params = new CapaPatchParam();
        }

        costComboBox.setModel(new DefaultComboBoxModel(project.getLinksetNames().toArray()));
        DefaultComboBoxModel model = new DefaultComboBoxModel(project.getCodes().toArray());
        codeList.setModel(model);

        if(!params.isCalcArea()) {
            if(params.importFile == null) {
                neighborhoodRadioButton.setSelected(true);
                if(params.costName != null) {
                    costComboBox.setSelectedItem(params.costName);
                }
                maxCostSpinner.setValue(params.maxCost);
                costWeightedCheckBox.setSelected(params.weightCost);
                int [] selInds = new int[params.codes.size()];
                int i = 0;
                for(Integer val : params.codes) {
                    selInds[i++] = model.getIndexOf(val);
                }
                codeList.setSelectedIndices(selInds);
            } else {
                csvImportRadioButton.setSelected(true);
                selectFilePanel.setSelectedFile(params.importFile);
                if(params.importFile.exists()) {
                    selectFilePanelActionPerformed(null);
                    idComboBox.setSelectedItem(params.idField);
                    capaComboBox.setSelectedItem(params.capaField);
                }
            }
        }
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        areaRadioButton = new javax.swing.JRadioButton();
        neighborhoodRadioButton = new javax.swing.JRadioButton();
        neighborhoodPanel = new javax.swing.JPanel();
        costComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        maxCostSpinner = new javax.swing.JSpinner();
        costWeightedCheckBox = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        codeList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        csvImportRadioButton = new javax.swing.JRadioButton();
        csvImportPanel = new javax.swing.JPanel();
        selectFilePanel = new org.thema.common.swing.SelectFilePanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        capaComboBox = new javax.swing.JComboBox();
        idComboBox = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle"); // NOI18N
        setTitle(bundle.getString("CapaPatchDialog.title")); // NOI18N

        okButton.setText(bundle.getString("CapaPatchDialog.okButton.text")); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("CapaPatchDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(areaRadioButton);
        areaRadioButton.setSelected(true);
        areaRadioButton.setText(bundle.getString("CapaPatchDialog.areaRadioButton.text")); // NOI18N
        areaRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeRadioButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(neighborhoodRadioButton);
        neighborhoodRadioButton.setText(bundle.getString("CapaPatchDialog.neighborhoodRadioButton.text")); // NOI18N
        neighborhoodRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeRadioButtonActionPerformed(evt);
            }
        });

        neighborhoodPanel.setEnabled(false);

        costComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel1.setText(bundle.getString("CapaPatchDialog.jLabel1.text")); // NOI18N

        jLabel2.setText(bundle.getString("CapaPatchDialog.jLabel2.text")); // NOI18N

        maxCostSpinner.setModel(new javax.swing.SpinnerNumberModel(0.0d, 0.0d, null, 1.0d));

        costWeightedCheckBox.setText(bundle.getString("CapaPatchDialog.costWeightedCheckBox.text")); // NOI18N

        jScrollPane1.setViewportView(codeList);

        jLabel3.setText(bundle.getString("CapaPatchDialog.jLabel3.text")); // NOI18N

        javax.swing.GroupLayout neighborhoodPanelLayout = new javax.swing.GroupLayout(neighborhoodPanel);
        neighborhoodPanel.setLayout(neighborhoodPanelLayout);
        neighborhoodPanelLayout.setHorizontalGroup(
            neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(neighborhoodPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(neighborhoodPanelLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(maxCostSpinner))
                    .addComponent(costWeightedCheckBox)
                    .addGroup(neighborhoodPanelLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(costComboBox, 0, 281, Short.MAX_VALUE)))
                .addGap(27, 27, 27)
                .addGroup(neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addContainerGap())
        );
        neighborhoodPanelLayout.setVerticalGroup(
            neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(neighborhoodPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(neighborhoodPanelLayout.createSequentialGroup()
                        .addGroup(neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(costComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(neighborhoodPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(maxCostSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(costWeightedCheckBox))
                    .addGroup(neighborhoodPanelLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE)))
                .addContainerGap())
        );

        buttonGroup1.add(csvImportRadioButton);
        csvImportRadioButton.setText(bundle.getString("CapaPatchDialog.csvImportRadioButton.text")); // NOI18N
        csvImportRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeRadioButtonActionPerformed(evt);
            }
        });

        csvImportPanel.setEnabled(false);

        selectFilePanel.setDescription(bundle.getString("CapaPatchDialog.selectFilePanel.description")); // NOI18N
        selectFilePanel.setFileDesc(bundle.getString("CapaPatchDialog.selectFilePanel.fileDesc")); // NOI18N
        selectFilePanel.setFileExts(bundle.getString("CapaPatchDialog.selectFilePanel.fileExts")); // NOI18N
        selectFilePanel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectFilePanelActionPerformed(evt);
            }
        });

        jLabel4.setText(bundle.getString("CapaPatchDialog.jLabel4.text")); // NOI18N

        jLabel5.setText(bundle.getString("CapaPatchDialog.jLabel5.text")); // NOI18N

        javax.swing.GroupLayout csvImportPanelLayout = new javax.swing.GroupLayout(csvImportPanel);
        csvImportPanel.setLayout(csvImportPanelLayout);
        csvImportPanelLayout.setHorizontalGroup(
            csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(csvImportPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(csvImportPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jLabel4)
                        .addComponent(jLabel5))
                    .addGap(40, 40, 40)
                    .addGroup(csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(idComboBox, 0, 239, Short.MAX_VALUE)
                        .addComponent(capaComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGap(12, 12, 12)))
        );
        csvImportPanelLayout.setVerticalGroup(
            csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(csvImportPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(104, Short.MAX_VALUE))
            .addGroup(csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(csvImportPanelLayout.createSequentialGroup()
                    .addGap(66, 66, 66)
                    .addGroup(csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel4)
                        .addComponent(idComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addGroup(csvImportPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel5)
                        .addComponent(capaComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(neighborhoodPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(csvImportRadioButton)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(csvImportPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(areaRadioButton)
                                    .addComponent(neighborhoodRadioButton))
                                .addGap(0, 0, Short.MAX_VALUE)))
                        .addContainerGap())))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cancelButton)
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(areaRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(neighborhoodRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(neighborhoodPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(csvImportRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(csvImportPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        params.calcArea = areaRadioButton.isSelected();
        params.importFile = null;
        if(csvImportRadioButton.isSelected()) {
            params.idField = idComboBox.getSelectedItem().toString();
            params.capaField = capaComboBox.getSelectedItem().toString();
            params.importFile = selectFilePanel.getSelectedFile();
        } else if(!params.calcArea) {
            params.costName = costComboBox.getSelectedItem().toString();
            params.codes = new HashSet(codeList.getSelectedValuesList());
            params.maxCost = (Double)maxCostSpinner.getValue();
            params.weightCost = costWeightedCheckBox.isSelected();
        }
        isOk = true;
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void selectFilePanelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectFilePanelActionPerformed
        try {
            CSVTabReader r = new CSVTabReader(selectFilePanel.getSelectedFile());
            idComboBox.setModel(new DefaultComboBoxModel(r.getVarNames().toArray()));
            capaComboBox.setModel(new DefaultComboBoxModel(r.getVarNames().toArray()));
            r.dispose();
        } catch (IOException ex) {
            Logger.getLogger(CapaPatchDialog.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading file :\n" + ex.getLocalizedMessage());
        }
    }//GEN-LAST:event_selectFilePanelActionPerformed

    private void typeRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_typeRadioButtonActionPerformed
        Util.setPanelEnabled(neighborhoodPanel, neighborhoodRadioButton.isSelected());
        Util.setPanelEnabled(csvImportPanel, csvImportRadioButton.isSelected());
    }//GEN-LAST:event_typeRadioButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton areaRadioButton;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox capaComboBox;
    private javax.swing.JList codeList;
    private javax.swing.JComboBox costComboBox;
    private javax.swing.JCheckBox costWeightedCheckBox;
    private javax.swing.JPanel csvImportPanel;
    private javax.swing.JRadioButton csvImportRadioButton;
    private javax.swing.JComboBox idComboBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner maxCostSpinner;
    private javax.swing.JPanel neighborhoodPanel;
    private javax.swing.JRadioButton neighborhoodRadioButton;
    private javax.swing.JButton okButton;
    private org.thema.common.swing.SelectFilePanel selectFilePanel;
    // End of variables declaration//GEN-END:variables

}
